Attribute VB_Name = "LibTapiCalls"
Option Explicit

Function Clean(c As String) As String
    '
    ' strip 0s from string
    '
    Dim l As Integer
    Dim x As Integer
    Dim s As String
    Dim n As Integer
    '
    l = Len(c)
    s = ""
    For x = 1 To Len(c)
        If Mid(c, x, 1) <> Chr(0) Then
            s = s + Mid(c, x, 1)
        Else
            s = s + " "
        End If
    Next
    '
    Clean = s
End Function

Public Function GetOffset(lLenStru As Long, lOffset As Long, lSize As Long, cExtraData As String) As String
    '
    ' return the data at the offset
    '
    GetOffset = Mid(cExtraData, lOffset - lLenStru + 1, lSize)
    '
End Function

Public Sub AddText(ctrlText As Control, sText As String)
    '
    ' add passed text to message box
    '
    ctrlText = sText & Chr(13) & Chr(10) & ctrlText
    '
End Sub

Public Sub LineCallInfoShow(ctrlText As Control, udtCall As LINECALLINFO, cExtraData As String)
    '
    ' show all the parts of LineCallInfo
    '
    AddText ctrlText, "TotalSize: " & CStr(udtCall.dwTotalSize)
    AddText ctrlText, "NeededSize: " & CStr(udtCall.dwNeededSize)
    AddText ctrlText, "dwUsedSize:" & CStr(udtCall.dwUsedSize)

    AddText ctrlText, "hLine:" & CStr(udtCall.hLine)
    AddText ctrlText, "dwLineDeviceID:" & CStr(udtCall.dwLineDeviceID)
    AddText ctrlText, "dwAddressID:" & CStr(udtCall.dwAddressID)

    AddText ctrlText, "dwBearerMode:" & CStr(udtCall.dwBearerMode)
    AddText ctrlText, "dwRate:" & CStr(udtCall.dwRate)
    AddText ctrlText, "dwMediaMode:" & CStr(udtCall.dwMediaMode)

    AddText ctrlText, "dwAppSpecific:" & CStr(udtCall.dwAppSpecific)
    AddText ctrlText, "dwCallID:" & CStr(udtCall.dwCallID)
    AddText ctrlText, "dwRelatedCallID:" & CStr(udtCall.dwRelatedCallID)
    AddText ctrlText, "dwCallParamFlags:" & CStr(udtCall.dwCallParamFlags)
    AddText ctrlText, "dwCallStates:" & CStr(udtCall.dwCallStates)

    AddText ctrlText, "dwMonitorDigitModes:" & CStr(udtCall.dwMonitorDigitModes)
    AddText ctrlText, "dwMonitorMediaModes:" & CStr(udtCall.dwMonitorMediaModes)
    'DialParams As LINEDIALPARAMS

    AddText ctrlText, "dwOrigin:" & CStr(udtCall.dwOrigin)
    AddText ctrlText, "dwReason:" & CStr(udtCall.dwReason)
    AddText ctrlText, "dwCompletionID:" & CStr(udtCall.dwCompletionID)
    AddText ctrlText, "dwNumOwners:" & CStr(udtCall.dwNumOwners)
    AddText ctrlText, "dwNumMonitors:" & CStr(udtCall.dwNumMonitors)

    AddText ctrlText, "dwCountryCode:" & CStr(udtCall.dwCountryCode)
    AddText ctrlText, "dwTrunk:" & CStr(udtCall.dwTrunk)

    AddText ctrlText, "dwCallerIDFlags:" & CStr(udtCall.dwCallerIDFlags)
    AddText ctrlText, "dwCallerIDSize:" & CStr(udtCall.dwCallerIDSize)
    AddText ctrlText, "dwCallerIDOffset:" & CStr(udtCall.dwCallerIDOffset)
    AddText ctrlText, "dwCallerIDNameSize:" & CStr(udtCall.dwCallerIDNameSize)
    AddText ctrlText, "dwCallerIDNameSize:" & CStr(udtCall.dwCallerIDNameSize)

    AddText ctrlText, "dwCalledIDFlags:" & CStr(udtCall.dwCalledIDFlags)
    AddText ctrlText, "dwCalledIDSize:" & CStr(udtCall.dwCalledIDSize)
    AddText ctrlText, "dwCalledIDOffset:" & CStr(udtCall.dwCalledIDOffset)
    AddText ctrlText, "dwCalledIDNameSize:" & CStr(udtCall.dwCalledIDNameSize)
    AddText ctrlText, "dwCalledIDNameOffset:" & CStr(udtCall.dwCalledIDNameOffset)

    AddText ctrlText, "dwConnectedIDFlags:" & CStr(udtCall.dwConnectedIDFlags)
    AddText ctrlText, "dwConnectedIDSize:" & CStr(udtCall.dwConnectedIDSize)
    AddText ctrlText, "dwConnectedIDOffset:" & CStr(udtCall.dwConnectedIDOffset)
    AddText ctrlText, "dwConnectedIDNameSize:" & CStr(udtCall.dwConnectedIDNameSize)
    AddText ctrlText, "dwConnectedIDNameOffset:" & CStr(udtCall.dwConnectedIDNameOffset)

    AddText ctrlText, "dwRedirectionIDFlags:" & CStr(udtCall.dwRedirectionIDFlags)
    AddText ctrlText, "dwRedirectionIDSize:" & CStr(udtCall.dwRedirectionIDSize)
    AddText ctrlText, "dwRedirectionIDOffset:" & CStr(udtCall.dwRedirectionIDOffset)
    AddText ctrlText, "dwRedirectionIDNameSize:" & CStr(udtCall.dwRedirectionIDNameSize)
    AddText ctrlText, "dwRedirectionIDNameOffset:" & CStr(udtCall.dwRedirectionIDNameOffset)

    AddText ctrlText, "dwRedirectingIDFlags:" & CStr(udtCall.dwRedirectingIDFlags)
    AddText ctrlText, "dwRedirectingIDSize:" & CStr(udtCall.dwRedirectingIDSize)
    AddText ctrlText, "dwRedirectingIDOffset:" & CStr(udtCall.dwRedirectingIDOffset)
    AddText ctrlText, "dwRedirectingIDNameSize:" & CStr(udtCall.dwRedirectingIDNameSize)
    AddText ctrlText, "dwRedirectingIDNameOffset:" & CStr(udtCall.dwRedirectingIDNameOffset)

    AddText ctrlText, "dwAppNameSize:" & CStr(udtCall.dwAppNameSize)
    AddText ctrlText, "dwAppNameOffset:" & CStr(udtCall.dwAppNameOffset)

    AddText ctrlText, "dwDisplayableAddressSize:" & CStr(udtCall.dwDisplayableAddressSize)
    AddText ctrlText, "dwDisplayableAddressOffset:" & CStr(udtCall.dwDisplayableAddressOffset)

    AddText ctrlText, "dwCalledPartySize:" & CStr(udtCall.dwCalledPartySize)
    AddText ctrlText, "dwCalledPartyOffset:" & CStr(udtCall.dwCalledPartyOffset)

    AddText ctrlText, "dwCommentSize:" & CStr(udtCall.dwCommentSize)
    AddText ctrlText, "dwCommentOffset:" & CStr(udtCall.dwCommentOffset)

    AddText ctrlText, "dwDisplaySize:" & CStr(udtCall.dwDisplaySize)
    AddText ctrlText, "dwDisplayOffset:" & CStr(udtCall.dwDisplayOffset)

    AddText ctrlText, "dwUserUserInfoSize:" & CStr(udtCall.dwUserUserInfoSize)
    AddText ctrlText, "dwUserUserInfoOffset:" & CStr(udtCall.dwUserUserInfoOffset)

    AddText ctrlText, "dwHighLevelCompSize:" & CStr(udtCall.dwHighLevelCompSize)
    AddText ctrlText, "dwHighLevelCompOffset:" & CStr(udtCall.dwHighLevelCompOffset)

    AddText ctrlText, "dwLowLevelCompSize:" & CStr(udtCall.dwLowLevelCompSize)
    AddText ctrlText, "dwLowLevelCompOffset:" & CStr(udtCall.dwLowLevelCompOffset)

    AddText ctrlText, "dwChargingInfoSize:" & CStr(udtCall.dwChargingInfoSize)
    AddText ctrlText, "dwChargingInfoOffset:" & CStr(udtCall.dwChargingInfoOffset)

    AddText ctrlText, "dwTerminalModesSize:" & CStr(udtCall.dwTerminalModesSize)
    AddText ctrlText, "dwTerminalModesOffset:" & CStr(udtCall.dwTerminalModesOffset)

    AddText ctrlText, "dwDevSpecificSize:" & CStr(udtCall.dwDevSpecificSize)
    AddText ctrlText, "dwDevSpecificOffset:" & CStr(udtCall.dwDevSpecificOffset)
    '
    AddText ctrlText, String(80, 45)
    '
End Sub

Public Function TapiCallBackHandler(hDevice As Long, dwMessage As Long, dwInstance As Long, dwParam1 As Long, dwParam2 As Long, dwParam3 As Long) As String
    '
    ' handle messages from TAPI control
    '
    Dim cMsg As String
    '
    Select Case dwMessage
        Case LINE_ADDRESSSTATE '(= 0&)
            cMsg = "MSG: Line_AddressState"
            cMsg = cMsg & "..."
            cMsg = cMsg & "AddressID=" & CStr(dwParam1)
            cMsg = cMsg & ", State=" & LineAddressStateMsg(dwParam2)
        Case LINE_CALLINFO '(= 1&)
            cMsg = "MSG: Line_CallInfo"
        Case LINE_CALLSTATE  '(= 2&)
            cMsg = "MSG: Line_CallState"
            cMsg = cMsg & "..."
            cMsg = cMsg & "CallState=" & LineCallStateMsg(dwParam1)
            '
            Select Case dwParam1
                Case LINECALLSTATE_BUSY
                    cMsg = cMsg & ", StateDependent=" & LineCallStateBusyMsg(dwParam2)
                Case LINECALLSTATE_DIALTONE
                    cMsg = cMsg & ", StateDependent=" & LineCallStateDialtoneMsg(dwParam2)
                Case LINECALLSTATE_DISCONNECTED
                    cMsg = cMsg & ", StateDependent=" & LineCallStateDisconnectedMsg(dwParam2)
                Case Else
                    cMsg = cMsg & ", StateDependent=" & CStr(dwParam2)
            End Select
            '
            cMsg = cMsg & ", Privilege=" & CStr(dwParam3)
        Case LINE_CLOSE '(= 3&)
            cMsg = "MSG: Line_Close"
        Case LINE_DEVSPECIFIC '(= 4&)
            cMsg = "MSG: Line_DevSpecific"
        Case LINE_DEVSPECIFICFEATURE '(= 5&)
            cMsg = "MSG: Line_DevSpecificFeature"
        Case LINE_GATHERDIGITS '(= 6&)
            cMsg = "MSG: Line_GatherDigits"
        Case LINE_GENERATE '(= 7&)
            cMsg = "MSG: Line_Generate"
        Case LINE_LINEDEVSTATE '(= 8&)
            cMsg = "MSG: Line_LineDevState"
        Case LINE_MONITORDIGITS '(= 9&)
            cMsg = "MSG: Line_MonitorDigits"
        Case LINE_MONITORMEDIA '(= 10&)
            cMsg = "MSG: Line_MonitorMedia"
        Case LINE_MONITORTONE '(= 11&)
            cMsg = "MSG: Line_MonitorTone"
        Case LINE_REPLY '(= 12&)
            cMsg = "MSG: Line_Reply...idRequest=" & CStr(dwParam1) & " - Status = " & LineErr(dwParam2)
        Case LINE_REQUEST '(= 13&)
            cMsg = "MSG: Line_Request"
        Case Else
            cMsg = "MSG: Unknown Message..." + CStr(dwMessage)
    End Select
    '
    TapiCallBackHandler = cMsg
    '
End Function



Public Function LineCallStateMsg(lparam As Long) As String
    '
    ' parse parameter into phrase
    '
    Dim cMsg As String
    '
    Select Case lparam
        Case LINECALLSTATE_IDLE '(= &H1&)
            cMsg = "Idle"
        Case LINECALLSTATE_OFFERING '(= &H2&)
            cMsg = "Offering"
        Case LINECALLSTATE_ACCEPTED '(= &H4&)
            cMsg = "Accepted"
        Case LINECALLSTATE_DIALTONE '(= &H8&)
            cMsg = "Dialtone"
        Case LINECALLSTATE_DIALING '(= &H10&)
            cMsg = "Dialing"
        Case LINECALLSTATE_RINGBACK '(= &H20&)
            cMsg = "RingBack"
        Case LINECALLSTATE_BUSY '(= &H40&)
            cMsg = "Busy"
        Case LINECALLSTATE_SPECIALINFO '(= &H80&)
            cMsg = "SpecialInfo"
        Case LINECALLSTATE_CONNECTED '(= &H100&)
            cMsg = "Connected"
        Case LINECALLSTATE_PROCEEDING '(= &H200&)
            cMsg = "Proceeding"
        Case LINECALLSTATE_ONHOLD '(= &H400&)
            cMsg = "OnHold"
        Case LINECALLSTATE_CONFERENCED '(= &H800&)
            cMsg = "Conferenced"
        Case LINECALLSTATE_ONHOLDPENDCONF '(= &H1000&)
            cMsg = "OnHoldPendConf"
        Case LINECALLSTATE_ONHOLDPENDTRANSFER '(= &H2000&)
            cMsg = "OnHoldPendTransfer"
        Case LINECALLSTATE_DISCONNECTED '(= &H4000&)
            cMsg = "Disconnected"
        Case LINECALLSTATE_UNKNOWN '(= &H8000&)
            cMsg = "Unknown"
    End Select
    '
    LineCallStateMsg = cMsg
    '
End Function

Public Function LineErr(lparam As Long) As String
    '
    ' handle Line Errors
    '
    Dim cMsg As String
    '
    Select Case lparam
        Case LINEERR_ALLOCATED '( = &H80000001)
            cMsg = "Allocated"
        Case LINEERR_BADDEVICEID '(= &H80000002)
            cMsg = "Bad Device ID"
        Case LINEERR_BEARERMODEUNAVAIL '(= &H80000003)
            cMsg = "Bearer Mode Unavail"
        Case LINEERR_CALLUNAVAIL '(= &H80000005)
            cMsg = "Call UnAvail"
        Case LINEERR_COMPLETIONOVERRUN '(= &H80000006
            cMsg = "Completion Overrun"
        Case LINEERR_CONFERENCEFULL '(= &H80000007
            cMsg = "Conference Full"
        Case LINEERR_DIALBILLING '(= &H80000008
            cMsg = "Dial Billing"
        Case LINEERR_DIALDIALTONE '(= &H80000009
            cMsg = "Dial Dialtone"
        Case LINEERR_DIALPROMPT '(= &H8000000A
            cMsg = "Dial Prompt"
        Case LINEERR_DIALQUIET '(= &H8000000B
            cMsg = "Dial Quiet"
        Case LINEERR_INCOMPATIBLEAPIVERSION '(= &H8000000C
            cMsg = "Incompatible API Version"
        Case LINEERR_INCOMPATIBLEEXTVERSION '(= &H8000000D
            cMsg = "Incompatible Ext Version"
        Case LINEERR_INIFILECORRUPT '(= &H8000000E
            cMsg = "Ini File Corrupt"
        Case LINEERR_INUSE '(= &H8000000F
            cMsg = "In Use"
        Case LINEERR_INVALADDRESS '(= &H80000010
            cMsg = "Invalid Address"
        Case LINEERR_INVALADDRESSID '(= &H80000011
            cMsg = "Invalid Address ID"
        Case LINEERR_INVALADDRESSMODE '(= &H80000012
            cMsg = "Invalid Address Mode"
        Case LINEERR_INVALADDRESSSTATE '(= &H80000013
            cMsg = "Invalid Address State"
        Case LINEERR_INVALAPPHANDLE '(= &H80000014
            cMsg = "Invalid App Handle"
        Case LINEERR_INVALAPPNAME '(= &H80000015
            cMsg = "Invalid App Name"
        Case LINEERR_INVALBEARERMODE '(= &H80000016
            cMsg = "Invalid Bearer Mode"
        Case LINEERR_INVALCALLCOMPLMODE '(= &H80000017
            cMsg = "Invalid Call Completion Mode"
        Case LINEERR_INVALCALLHANDLE '(= &H80000018
            cMsg = "Invalid Call Handle"
        Case LINEERR_INVALCALLPARAMS '(= &H80000019
            cMsg = "Invalid Call Params"
        Case LINEERR_INVALCALLPRIVILEGE '(= &H8000001A
            cMsg = "Invalid Call Privilege"
        Case LINEERR_INVALCALLSELECT '(= &H8000001B
            cMsg = "Invalid Call Select"
        Case LINEERR_INVALCALLSTATE '(= &H8000001C
            cMsg = "Invalid Call State"
        Case LINEERR_INVALCALLSTATELIST '(= &H8000001D
            cMsg = "Invalid Call State List"
        Case LINEERR_INVALCARD '(= &H8000001E
            cMsg = "Invalid Card"
        Case LINEERR_INVALCOMPLETIONID '(= &H8000001F
            cMsg = "Invalid Completion ID"
        Case LINEERR_INVALCONFCALLHANDLE '(= &H80000020
            cMsg = "Invalid Conf Call Handle"
        Case LINEERR_INVALCONSULTCALLHANDLE '(= &H80000021
            cMsg = "Invalid Consult Call Handle"
        Case LINEERR_INVALCOUNTRYCODE '(= &H80000022
            cMsg = "Invalid Country Code"
        Case LINEERR_INVALDEVICECLASS '(= &H80000023
            cMsg = "Invalid Device Class"
        Case LINEERR_INVALDEVICEHANDLE '(= &H80000024
            cMsg = "Invalid Device Handle"
        Case LINEERR_INVALDIGITLIST '(= &H80000026
            cMsg = "Invalid Digit List"
        Case LINEERR_INVALDIGITMODE '(= &H80000027
            cMsg = "Invalid Digit Mode"
        Case LINEERR_INVALDIGITS '(= &H80000028
            cMsg = "Invalid Digits"
        Case LINEERR_INVALEXTVERSION '(= &H80000029
            cMsg = "Invalid Ext Version"
        Case LINEERR_INVALGROUPID '(= &H8000002A
            cMsg = "Invalid Group ID"
        Case LINEERR_INVALLINEHANDLE '(= &H8000002B
            cMsg = "Invalid Line Handle"
        Case LINEERR_INVALLINESTATE '(= &H8000002C
            cMsg = "Invalid Line State"
        Case LINEERR_INVALLOCATION '(= &H8000002D
            cMsg = "Invalid Location"
        Case LINEERR_INVALMEDIALIST '(= &H8000002E
            cMsg = "Invalid Media List"
        Case LINEERR_INVALMEDIAMODE '(= &H8000002F
            cMsg = "Invalid Media Mode"
        Case LINEERR_INVALMESSAGEID '(= &H80000030
            cMsg = "Invalid Message ID"
        Case LINEERR_INVALPARAM '(= &H80000032
            cMsg = "Invalid Param"
        Case LINEERR_INVALPARKID '(= &H80000033
            cMsg = "Invalid Park ID"
        Case LINEERR_INVALPARKMODE '(= &H80000034
            cMsg = "Invalid Park Mode"
        Case LINEERR_INVALPOINTER '(= &H80000035
            cMsg = "Invalid Pointer"
        Case LINEERR_INVALPRIVSELECT '(= &H80000036
            cMsg = "Invalid Priv Select"
        Case LINEERR_INVALRATE '(= &H80000037
            cMsg = "Invalid Rate"
        Case LINEERR_INVALREQUESTMODE '(= &H80000038
            cMsg = "Invalid Request Mode"
        Case LINEERR_INVALTERMINALID '(= &H80000039
            cMsg = "Invalid Terminal ID"
        Case LINEERR_INVALTERMINALMODE '(= &H8000003A
            cMsg = "Invalid Terminal Mode"
        Case LINEERR_INVALTIMEOUT '(= &H8000003B
            cMsg = "Invalid Time Out"
        Case LINEERR_INVALTONE '(= &H8000003C
            cMsg = "Invalid Tone"
        Case LINEERR_INVALTONELIST '(= &H8000003D
            cMsg = "Invalid Tone List"
        Case LINEERR_INVALTONEMODE '(= &H8000003E
            cMsg = "Invalid Tone Mode"
        Case LINEERR_INVALTRANSFERMODE '(= &H8000003F
            cMsg = "Invalid Transfer Mode"
        Case LINEERR_LINEMAPPERFAILED '(= &H80000040
            cMsg = "Line Mapper Failed"
        Case LINEERR_NOCONFERENCE '(= &H80000041
            cMsg = "No Conference"
        Case LINEERR_NODEVICE '(= &H80000042
            cMsg = "No Device"
        Case LINEERR_NODRIVER '(= &H80000043
            cMsg = "No Driver"
        Case LINEERR_NOMEM '(= &H80000044
            cMsg = "No Memory"
        Case LINEERR_NOREQUEST '(= &H80000045
            cMsg = "No Request"
        Case LINEERR_NOTOWNER '(= &H80000046
            cMsg = "Not Owner"
        Case LINEERR_NOTREGISTERED '(= &H80000047
            cMsg = "Not Registered"
        Case LINEERR_OPERATIONFAILED '(= &H80000048
            cMsg = "Operation Failed"
        Case LINEERR_OPERATIONUNAVAIL '(= &H80000049
            cMsg = "Operation Unavailable"
        Case LINEERR_RATEUNAVAIL '(= &H8000004A
            cMsg = "Rate Unavailable"
        Case LINEERR_RESOURCEUNAVAIL '(= &H8000004B
            cMsg = "Resource Unavailable"
        Case LINEERR_REQUESTOVERRUN '(= &H8000004C
            cMsg = "Request Overrun"
        Case LINEERR_STRUCTURETOOSMALL '(= &H8000004D
            cMsg = "Structure Too Small"
        Case LINEERR_TARGETNOTFOUND '(= &H8000004E
            cMsg = "Target Not found"
        Case LINEERR_TARGETSELF '(= &H8000004F
            cMsg = "Target Self"
        Case LINEERR_UNINITIALIZED '(= &H80000050
            cMsg = "Uninitialized"
        Case LINEERR_USERUSERINFOTOOBIG '(= &H80000051
            cMsg = "UserUser Info Too Big"
        Case LINEERR_REINIT '(= &H80000052
            cMsg = "Re-init"
        Case LINEERR_ADDRESSBLOCKED '(= &H80000053
            cMsg = "Address Blocked"
        Case LINEERR_BILLINGREJECTED '(= &H80000054
            cMsg = "Billing Rejected"
        Case LINEERR_INVALFEATURE '(= &H80000055
            cMsg = "Invalid Feature"
        Case LINEERR_NOMULTIPLEINSTANCE '(= &H80000056
            cMsg = "No Multiple Instance"
    End Select
    '
    LineErr = cMsg
    '
End Function

Public Function LineCallStateBusyMsg(lparam As Long) As String
    '
    ' handle line busy messages
    '
    Dim cMsg As String
    '
    Select Case lparam
        Case LINEBUSYMODE_STATION '= &H1&
            cMsg = "Line Busy - Station"
        Case LINEBUSYMODE_TRUNK '= &H2&
            cMsg = "Line Busy - Trunk"
        Case LINEBUSYMODE_UNKNOWN '= &H4&
            cMsg = "Line Busy - Unknown"
        Case LINEBUSYMODE_UNAVAIL '= &H8&
            cMsg = "Line Busy - Unavail"
    End Select
    '
    LineCallStateBusyMsg = cMsg
    '
End Function

Public Function LineCallStateDialtoneMsg(lparam As Long) As String
    '
    ' handle dialtone messages
    '
    Dim cMsg As String
    '
    Select Case lparam
        Case LINEDIALTONEMODE_NORMAL ' &H1&
            cMsg = "Dialtone Normal"
        Case LINEDIALTONEMODE_SPECIAL ' &H2&
            cMsg = "Dialtone Special"
        Case LINEDIALTONEMODE_INTERNAL ' &H4&
            cMsg = "Dialton Internal"
        Case LINEDIALTONEMODE_EXTERNAL ' &H8&
            cMsg = "Dialtone External"
        Case LINEDIALTONEMODE_UNKNOWN ' &H10&
            cMsg = "Dialtone Unknown"
        Case LINEDIALTONEMODE_UNAVAIL ' &H20&
            cMsg = "Dialtone Unavail"
    End Select
    '
    LineCallStateDialtoneMsg = cMsg
    '
End Function


Public Function LineAddressStateMsg(dwParam As Long) As String
    '
    ' translate message values
    '
    Dim cReturn As String
    '
    Select Case dwParam
        Case Is = LINEADDRESSSTATE_OTHER ' &H1&
            cReturn = "Other values changed(?)"
        Case Is = LINEADDRESSSTATE_DEVSPECIFIC ' &H2&
            cReturn = "DevSpecific value changed"
        Case Is = LINEADDRESSSTATE_INUSEZERO ' &H4&
            cReturn = "In use by zero stations"
        Case Is = LINEADDRESSSTATE_INUSEONE ' &H8&
            cReturn = "In use by only one station"
        Case Is = LINEADDRESSSTATE_INUSEMANY ' &H10&
            cReturn = "In use by many stations"
        Case Is = LINEADDRESSSTATE_NUMCALLS ' &H20&
            cReturn = "Number of calls has changed"
        Case Is = LINEADDRESSSTATE_FORWARD ' &H40&
            cReturn = "Forwarding status has changed"
        Case Is = LINEADDRESSSTATE_TERMINALS ' &H80&
            cReturn = "Terminal settings have changed"
        Case Else
            cReturn = "Unknown LineAddressState Msg [" & CStr(dwParam) & "]"
    End Select
    '
    LineAddressStateMsg = cReturn
    '
End Function

Public Function LineCallStateDisconnectedMsg(dwParam As Long) As String
    '
    ' handle message values
    '
    Dim cReturn As String
    '
    Select Case dwParam
        Case LINEDISCONNECTMODE_NORMAL ' &H1&
            cReturn = "Normal"
        Case LINEDISCONNECTMODE_UNKNOWN ' &H2&
            cReturn = "Unknown"
        Case LINEDISCONNECTMODE_REJECT ' &H4&
            cReturn = "Rejected"
        Case LINEDISCONNECTMODE_PICKUP ' &H8&
            cReturn = "Picked Up"
        Case LINEDISCONNECTMODE_FORWARDED ' &H10&
            cReturn = "Forwarded"
        Case LINEDISCONNECTMODE_BUSY ' &H20&
            cReturn = "Busy"
        Case LINEDISCONNECTMODE_NOANSWER ' &H40&
            cReturn = "No Answer"
        Case LINEDISCONNECTMODE_BADADDRESS ' &H80&
            cReturn = "Invalid Address"
        Case LINEDISCONNECTMODE_UNREACHABLE ' &H100&
            cReturn = "Unreachable"
        Case LINEDISCONNECTMODE_CONGESTION ' &H200&
            cReturn = "Congested Network"
        Case LINEDISCONNECTMODE_INCOMPATIBLE ' &H400&
            cReturn = "Incompatible Equipment"
        Case LINEDISCONNECTMODE_UNAVAIL ' &H800&
            cReturn = "Reason Unavailable"
        Case Else
            cReturn = "Unknown LineCallStateDisconnected Msg [" & CStr(dwParam) & "]"
    End Select
    '
    LineCallStateDisconnectedMsg = cReturn
    '
End Function

