Attribute VB_Name = "LibTBook"
Option Explicit


'
' declare tapi-assist API
'
#If Win16 Then
    Declare Function tapiRequestMakeCall Lib "TAPI.DLL" (ByVal lpszDestAddress As String, ByVal lpszAppName As String, ByVal lpszCalledParty As String, ByVal lpszComment As String) As Long
#Else
    Declare Function tapiRequestMakeCall Lib "TAPI32.DLL" (ByVal lpszDestAddress As String, ByVal lpszAppName As String, ByVal lpszCalledParty As String, ByVal lpszComment As String) As Long
#End If



Public Function LoadRec(cTBName As String) As Boolean
    '
    ' load record data from
    ' frmTelebook to frmTbMaster
    '
    Dim nFlds As Integer
    Dim X As Integer
    Dim lReturn As Boolean
    '
    frmTeleBook.Data1.Recordset.FindFirst "Name='" + cTBName + "'"
    If frmTeleBook.Data1.Recordset.NoMatch = False Then
        nFlds = frmTeleBook.Data1.Recordset.Fields.Count
        For X = 0 To nFlds - 1
            frmTbMaster.txtFields(X) = frmTeleBook.Data1.Recordset.Fields(X)
        Next X
        lReturn = True
    Else
        lReturn = False
    End If
    '
    LoadRec = lReturn
    '
End Function

Public Sub SaveRec(cTBName As String, cAction As String)
    '
    ' move data from frmTBMaster
    ' to frmTeleBook.data1
    '
    Dim nFlds As Integer
    Dim X As Integer
    '
    cAction = UCase(cAction)
    If cAction = "ADD" Then
        frmTeleBook.Data1.Recordset.AddNew
    Else
        frmTeleBook.Data1.Recordset.FindFirst "Name='" + cTBName + "'"
        If frmTeleBook.Data1.Recordset.NoMatch = False Then
            frmTeleBook.Data1.Recordset.Edit
        Else
            frmTeleBook.Data1.Recordset.AddNew
        End If
    End If
    '
    nFlds = frmTeleBook.Data1.Recordset.Fields.Count
    For X = 0 To nFlds - 1
        frmTeleBook.Data1.Recordset.Fields(X) = frmTbMaster.txtFields(X)
    Next X
    '
    frmTeleBook.Data1.Recordset.Update
    '
End Sub

Public Sub ClearRec()
    '
    ' clear input form
    '
    Dim nFlds As Integer
    Dim X As Integer
    '
    nFlds = frmTeleBook.Data1.Recordset.Fields.Count
    For X = 0 To nFlds - 1
        frmTbMaster.txtFields(X) = ""
    Next X
    '
End Sub

Public Sub CallRec()
    '
    ' call the book entry
    '
    Dim lTapi As Long                   ' return value
    Dim TBCall As New ClsPhoneCall      ' declare new object
    '
    TBCall.DestAddress = frmTeleBook.Data1.Recordset.Fields("Phone")
    TBCall.CalledParty = frmTeleBook.Data1.Recordset.Fields("Name")
    TBCall.AppName = "Dialer.exe"       ' set service provider
    '
    lTapi = TBCall.RequestMakeCall      ' make the call
End Sub
