VERSION 4.00
Begin VB.Form frmSMAPI 
   Caption         =   "Simple MAPI Demo"
   ClientHeight    =   5940
   ClientLeft      =   2130
   ClientTop       =   1515
   ClientWidth     =   6690
   Height          =   6345
   Left            =   2070
   LinkTopic       =   "Form1"
   ScaleHeight     =   5940
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
   Begin VB.CommandButton Command1 
      Caption         =   "ReadMail"
      Height          =   495
      Index           =   7
      Left            =   4260
      TabIndex        =   7
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "SendDialog"
      Height          =   495
      Index           =   6
      Left            =   2880
      TabIndex        =   6
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "SendDocs"
      Height          =   495
      Index           =   5
      Left            =   2880
      TabIndex        =   5
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "AddrDetails"
      Height          =   495
      Index           =   4
      Left            =   1500
      TabIndex        =   4
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "ResolveName"
      Height          =   495
      Index           =   3
      Left            =   1500
      TabIndex        =   3
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "AddressBook"
      Height          =   495
      Index           =   2
      Left            =   1500
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "LogOff"
      Height          =   495
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "LogOn"
      Height          =   495
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmSMAPI"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
'
Dim lReturn As Long ' return flag
Dim lSession As Long ' session handle
Dim udtMessage As MapiMessage ' message object
Dim udtRecip As MapiRecip ' recipient object
Dim udtRecips() As MapiRecip ' recipient collection
Dim udtFile As MapiFile ' attachment object
Dim udtFiles() As MapiFile ' attachment collection


Private Sub Command1_Click(Index As Integer)
    '
    ' handle button press
    '
    Select Case Index
        Case 0 ' log on session
            SMAPIStart
        Case 1 ' log off session
            SMAPIEnd
        Case 2 ' addressbook
            AddressBook
        Case 3 ' resolve name
            ResolveName
        Case 4 ' addr details
            AddrDetails
        Case 5 ' send documents
            SendDocs
        Case 6 ' sendmail w/ dialog
            SendDialog
        Case 7 ' read mail
            ReadMail
    End Select
    '
End Sub

Public Sub SMAPIStart()
    '
    ' start an SMAPI session
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPILogon(Me.hWnd, "MCA", "", MAPI_LOGON_UI And MAPI_NEW_SESSION And MAPI_FORCE_DOWNLOAD, 0, lSession)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
    Else
        MsgBox "MAPI Session ID: " & CStr(lSession), vbInformation, "SMAPI Logon"
    End If
    '
End Sub

Public Sub SMAPIEnd()
    '
    ' end an SMAPI session
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPILogoff(lSession, Me.hWnd, 0, 0)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
    Else
        MsgBox "MAPI Session Closed", vbInformation, "SMAPI LogOff"
    End If
    '
End Sub

Public Sub AddressBook()
    '
    ' call up the address book
    '
    On Error Resume Next
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPIAddress(lSession, Me.hWnd, "SMAPI Address Book", 3, "", 0, udtRecips(), 0, 0)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
    End If
    '
    MsgBox "Selected Recipients: " & CStr(UBound(udtRecips) + 1), vbInformation, "AddressBook"
    '
End Sub


Public Sub ResolveName()
    '
    ' test resolvename service
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPIResolveName(lSession, Me.hWnd, "MCA", MAPI_DIALOG, 0, udtRecip)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
    End If
    '
End Sub

Public Sub AddrDetails()
    '
    ' show the details of a valid address
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPIResolveName(lSession, Me.hWnd, "DSC/Fax", 0, 0, udtRecip)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
        Exit Sub
    End If
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPIDetails(lSession, Me.hWnd, udtRecip, MAPI_LOGON_UI, 0)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
    End If
    '
End Sub

Public Sub SendDocs()
    '
    ' start senddocuments
    '
    Dim cFiles As String
    Dim cNames As String
    Dim cDelim As String
    '
    cDelim = ";"
    cFiles = "C:\WINDOWS\WIN.INI;C:\CONFIG.SYS"
    cNames = "WIN.INI;CONFIG.SYS"
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPISendDocuments(Me.hWnd, cDelim, cFiles, cNames, 0)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
    End If
    '
End Sub

Public Sub SendDialog()
    '
    ' use sendmail w/ dialog
    '
    ' first build message
    udtMessage.Subject = "My Subject"
    udtMessage.NoteText = "This was written using VB Code"
    '
    ' next get valid recipient
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPIResolveName(lSession, Me.hWnd, "MCA/Win", 0, 0, udtRecip)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
        Exit Sub
    End If
    '
    ' now add recipient to the message
    udtMessage.RecipCount = 1
    udtMessage.FileCount = 0 '<<< required to prevent error msgs
    '
    ' now call sendmail w/ dialog
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPISendMail(lSession, Me.hWnd, udtMessage, udtRecip, udtFile, MAPI_DIALOG, 0)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
    End If
    '
End Sub

Public Sub ReadMail()
    '
    ' read the first message in the Inbox
    '
    Dim cMsgID As String
    Dim udtOrig As MapiRecip
    Dim cMsg As String
    Dim cMsgType As String
    '
    cMsgID = Space(256)
    cMsgType = ""
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPIFindNext(lSession, Me.hWnd, cMsgType, cMsgID, MAPI_GUARANTEE_FIFO, 0, cMsgID)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
        Exit Sub
    End If
    '
    lReturn = SUCCESS_SUCCESS
    lReturn = MAPIReadMail(lSession, Me.hWnd, cMsgID, MAPI_PEEK, 0, udtMessage, udtOrig, udtRecips, udtFiles)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
        Exit Sub
    End If
    '
    cMsg = cMsg & "Message.Subject: " & udtMessage.Subject & Chr(13)
    cMsg = cMsg & "Originator.Name: " & udtOrig.Name & Chr(13)
    MsgBox cMsg, vbInformation, "ReadMail"
    '
End Sub

Private Sub Command2_Click()

End Sub
