VERSION 4.00
Begin VB.Form frmTapiAns 
   Caption         =   "Form1"
   ClientHeight    =   3120
   ClientLeft      =   1305
   ClientTop       =   1560
   ClientWidth     =   6630
   Height          =   3525
   Left            =   1245
   LinkTopic       =   "Form1"
   ScaleHeight     =   3120
   ScaleWidth      =   6630
   Top             =   1215
   Width           =   6750
   Begin VB.TextBox txtStatus 
      BackColor       =   &H00C0C0C0&
      Height          =   1635
      Left            =   1500
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   5
      Text            =   "tapians.frx":0000
      Top             =   1320
      Width           =   4995
   End
   Begin VB.ListBox lstLines 
      Height          =   1035
      Left            =   1500
      TabIndex        =   4
      Top             =   120
      Width           =   3195
   End
   Begin VB.CommandButton cmdButton 
      Caption         =   "E&xit"
      Height          =   495
      Index           =   3
      Left            =   120
      TabIndex        =   3
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton cmdButton 
      Caption         =   "&Hang Up"
      Height          =   495
      Index           =   2
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton cmdButton 
      Caption         =   "&Answer Call"
      Height          =   495
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdButton 
      Caption         =   "&Start"
      Height          =   495
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Image Image1 
      Height          =   1035
      Left            =   4800
      Picture         =   "tapians.frx":0006
      Stretch         =   -1  'True
      Top             =   180
      Width           =   1695
   End
   Begin MCI.MMControl MMControl1 
      Height          =   330
      Left            =   180
      TabIndex        =   6
      Top             =   2460
      Visible         =   0   'False
      Width           =   3540
      _Version        =   65536
      _ExtentX        =   6244
      _ExtentY        =   582
      _StockProps     =   32
      BorderStyle     =   1
   End
   Begin TapilineLib.Tapiline Tapiline1 
      Left            =   600
      Top             =   2820
      _Version        =   65536
      _ExtentX        =   529
      _ExtentY        =   529
      _StockProps     =   0
   End
End
Attribute VB_Name = "frmTapiAns"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdButton_Click(Index As Integer)
    '
    ' open a line for monitoring
    '
    Dim lRtn As Long
    Dim lPrivilege As Long
    Dim lMediaMode As Long
    '
    ' check for start up selection only
    If Index = 0 Then
        If lstLines.ListIndex = -1 Then
            MsgBox "Select a line first!", vbInformation
            Exit Sub
        End If
    End If
    '
    ' set line parameters
    lPrivilege = LINECALLPRIVILEGE_OWNER + LINECALLPRIVILEGE_MONITOR
    lMediaMode = LINEMEDIAMODE_INTERACTIVEVOICE
    '
    Select Case Index
        Case 0 ' start looking
            lRtn = Tapiline1.LineOpen(lstLines.ListIndex, 0, LINECALLPRIVILEGE_OWNER + LINECALLPRIVILEGE_MONITOR, LINEMEDIAMODE_INTERACTIVEVOICE)
            If lRtn < 0 Then
                AddText txtStatus, "<<LineOpen ERROR>> " & LineErr(lRtn)
            Else
                AddText txtStatus, "LineOpen Successful"
                AddText txtStatus, "Waiting for an incoming call..."
                '
                cmdButton(0).Enabled = False
                cmdButton(1).Enabled = True
                cmdButton(2).Enabled = True
                '
            End If
        Case 1 ' answer call
            lRtn = Tapiline1.LineAnswer("", 0) ' only needed for ISDN
            If (lRtn < 0) Then
                AddText txtStatus, "<<LineAnswer ERROR>> " & LineErr(lRtn)
            Else
                AddText txtStatus, "LineAnswer Successful"
            End If
        Case 2 ' disconnect call
            Tapiline1.LineDrop "", 0 ' no parms unless ISDN!
            Tapiline1.LineClose
            '
            cmdButton(0).Enabled = True
            cmdButton(1).Enabled = False
            cmdButton(2).Enabled = False
            '
            ClearHandles ' clean up control handles
            AddText txtStatus, "Line Dropped and Closed"
        Case 3 ' exit program
            Unload Me
    End Select
    '
End Sub

Private Sub Form_Load()
    '
    ClearHandles ' start clean
    TapiStart ' init tapi & get version
    TapiGetDevCaps ' get device names
    MCIStart ' init multimedia control
    '
    Me.Left = (Screen.Width - Me.Width) / 2
    Me.Top = (Screen.Height - Me.Height) / 2
    '
    Me.Caption = "TAPI Answer Demo"
    Me.Image1.Picture = LoadPicture(App.Path & "\phone.wmf")
    txtStatus = ""
    '
    cmdButton(1).Enabled = False
    cmdButton(2).Enabled = False
    '
End Sub

Public Sub TapiStart()
    '
    ' start tapi and get lines
    '
    Dim x As Integer
    Dim lRtn As Long
    '
    lRtn = Tapiline1.LineInitialize(App.EXEName)
    If lRtn < 0 Then
        MsgBox "Unable to Start TAPI!", vbCritical
        Unload Me
    End If
    '
    For x = 0 To Tapiline1.NumDevices - 1
        Tapiline1.LineNegotiateAPIVersion x, &H10000, &H10004
    Next x
    '
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '
    ' close up shop
    '
    Tapiline1.LineDrop "", 0 ' drop active call
    Tapiline1.LineClose ' close open line
    Tapiline1.LineShutdown ' uninit TAPI
    '
End Sub


Private Sub lstLines_DblClick()
    '
    cmdButton_Click 0 ' force line selection
    '
End Sub

Private Sub MMControl1_Done(NotifyCode As Integer)
    '
    ' rewind wave for next time
    MMControl1.Command = "prev"
    '
End Sub

Private Sub Tapiline1_TapiCallBack(ByVal hDevice As Long, ByVal dwMessage As Long, ByVal dwInstance As Long, ByVal dwParam1 As Long, ByVal dwParam2 As Long, ByVal dwParam3 As Long)
    '
    ' handle TAPI messages
    '
    Dim cMsg As String
    '
    ' handle call actions
    Select Case dwMessage
        Case LINE_CALLSTATE ' state of call on line changed
            Select Case dwParam1
                Case LINECALLSTATE_OFFERING ' get call handle
                    Tapiline1.HandleToCall = hDevice ' update handle to call
                    MMControl1.Command = "play" ' ring me!
                Case LINECALLSTATE_IDLE ' they hung up on me!
                    Tapiline1.LineDeallocateCall ' dump pointer
                    Tapiline1.HandleToCall = 0 ' clear property
                    AddText txtStatus, "LineDeallocate Successful"
            End Select
        Case LINE_CLOSE ' line was closed
            cmdButton_Click 2 ' force hangup
    End Select
    '
    ' report status to user
    cMsg = TapiCallBackHandler(hDevice, dwMessage, dwInstance, dwParam1, dwParam2, dwParam3)
    AddText txtStatus, cMsg
    '
End Sub

Public Sub TapiGetDevCaps()
    '
    ' load device names into list box
    '
    Dim a As Long
    Dim b As LINEDEVCAPS
    Dim c As String * 2048
    Dim x As Integer
    '
    For x = 0 To Tapiline1.NumDevices - 1
        ' make the call to get dev caps
        a = Tapiline1.LineGetDevCaps(x)
        If a < 0 Then
            lstLines.AddItem "<<<ERROR>>> DevCaps..." & LineErr(a)
        Else
            LineDevCapsFunc TAPI_READ, b, c
            c = Clean(c)
            lstLines.AddItem GetOffset(Len(b) + 4, b.dwLineNameOffset, b.dwLineNameSize, c)
        End If
    Next x
    '
End Sub

Public Sub ClearHandles()
    '
    ' set all control handles to zero
    '
    Tapiline1.LineHandle = 0
    Tapiline1.HandleToCall = 0
    Tapiline1.AddressID = 0
    '
End Sub

Public Sub MCIStart()
    '
    ' init MCI control for ringing phone
    '
    MMControl1.Notify = False
    MMControl1.Wait = True
    MMControl1.Shareable = False
    MMControl1.DeviceType = "WaveAudio"
    MMControl1.filename = App.Path & "\ringin.wav"
    MMControl1.Command = "Open"
    '
End Sub
