VERSION 4.00
Begin VB.Form frmVPhone 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   3105
   ClientLeft      =   1815
   ClientTop       =   2790
   ClientWidth     =   6600
   Height          =   3795
   Icon            =   "VPHONE.frx":0000
   Left            =   1755
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3105
   ScaleWidth      =   6600
   ShowInTaskbar   =   0   'False
   Top             =   2160
   Width           =   6720
   Begin VB.CommandButton cmdPhone 
      Caption         =   "&Help"
      Height          =   300
      Index           =   4
      Left            =   5280
      TabIndex        =   7
      Top             =   2580
      Width           =   1200
   End
   Begin VB.CommandButton cmdPhone 
      Caption         =   "E&xit"
      Height          =   300
      Index           =   3
      Left            =   5280
      TabIndex        =   6
      Top             =   2160
      Width           =   1200
   End
   Begin VB.CommandButton cmdPhone 
      Caption         =   "&Edit"
      Height          =   300
      Index           =   2
      Left            =   5280
      TabIndex        =   5
      Top             =   1740
      Width           =   1200
   End
   Begin VB.CommandButton cmdPhone 
      Caption         =   "&Delete"
      Height          =   300
      Index           =   1
      Left            =   5280
      TabIndex        =   4
      Top             =   1320
      Width           =   1200
   End
   Begin VB.CommandButton cmdPhone 
      Caption         =   "&New"
      Height          =   300
      Index           =   0
      Left            =   5280
      TabIndex        =   3
      Top             =   900
      Width           =   1200
   End
   Begin VB.ListBox List1 
      BeginProperty Font 
         name            =   "MS LineDraw"
         charset         =   2
         weight          =   400
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   2370
      Left            =   120
      TabIndex        =   2
      Top             =   540
      Width           =   4995
   End
   Begin VB.CommandButton cmdDial 
      Caption         =   "&Place Call"
      Height          =   300
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1200
   End
   Begin VB.TextBox txtDial 
      Height          =   300
      Left            =   1440
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   120
      Width           =   3660
   End
   Begin VB.Image Image1 
      Height          =   615
      Left            =   5520
      Picture         =   "VPHONE.frx":0442
      Stretch         =   -1  'True
      Top             =   120
      Width           =   675
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileItem 
         Caption         =   "&New..."
         Index           =   0
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "&Edit..."
         Index           =   1
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "&Delete"
         Index           =   2
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "-"
         Index           =   3
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "&Place Call"
         Index           =   4
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "-"
         Index           =   5
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "E&xit"
         Index           =   6
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpItem 
         Caption         =   "Help..."
         Index           =   0
      End
      Begin VB.Menu mnuHelpItem 
         Caption         =   "&About..."
         Index           =   1
      End
   End
End
Attribute VB_Name = "frmVPhone"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdDial_Click()
    '
    ' try to place the call
    '
    If Trim(txtDial) <> "" Then
        PlaceCall txtDial, "" ' call dialer
    Else
        If List1.ListIndex > 0 Then
            List1_DblClick
            PlaceCall txtDial, ""
        Else
            MsgBox "Select a Name from the List", vbExclamation, "Place a Call"
        End If
    End If
    '
End Sub

Private Sub cmdPhone_Click(Index As Integer)
    '
    ' handle user selections
    '
    Dim cName As String
    Dim iAns As Integer
    Dim x As Integer
    '
    Select Case Index
        Case 0 ' add a record
            AddRec
        Case 1 ' delete a record
            If List1.ListIndex > 0 Then ' skip first line!
                cName = Left(List1.List(List1.ListIndex), 20)
                DeleteRec cName
            End If
        Case 2 ' edit a record
            If List1.ListIndex > 0 Then
                cName = Left(List1.List(List1.ListIndex), 20)
                EditRec cName
            End If
        Case 3 ' exit
            Unload Me
            End
        Case 4 ' help
            objVText.Speak cUserMsgs(ttsVPhone), iVType
            objVText.Speak cUserMsgs(ttsList), iVType
            objVText.Speak cUserMsgs(ttsExit), iVType
    End Select
    '
    ' update lists
    LoadList
    LoadNameList
    '
End Sub

Private Sub Form_Load()
    '
    ' set form properties
    Me.Caption = "Voice Phone"
    Me.Icon = LoadPicture(App.Path & "\vphone.ico")
    Image1.Picture = LoadPicture(App.Path & "\vphone.ico")
    Image1.Stretch = True
    CenterForm Me
    '
    ' initialize objects
    InitVCmd ' start SR engine
    InitVTxt ' start TTS engine
    InitDB ' state DB engine
    LoadNameList ' fill SR list
    LoadList ' fill onscreen list
    LoadMsgs ' fill TTS list
    '
    ' set variables
    txtDial = ""
    iVType = vtxtst_READING + vtxtsp_NORMAL
    '
    objVText.Speak cUserMsgs(ttsHello), iVType
    '
End Sub

Public Sub LoadList()
    '
    ' fill onscreen list with name/phone
    '
    Dim cLine As String
    List1.Clear
    '
    ' add header line first
    List1.AddItem "NAME" & String(16, ".") & Space(5) & "PHONE" & String(15, ".")
    '
    ' now add database items
    rsPhone.MoveFirst
    Do Until rsPhone.EOF
        cLine = Space(50)
        Mid(cLine, 1, 20) = Left(rsPhone.Fields("Name"), 20)
        Mid(cLine, 26, 20) = Left(rsPhone.Fields("Phone"), 20)
        List1.AddItem cLine
        rsPhone.MoveNext
    Loop
    '
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '
    ' destroy objects
    Set objVMenu = Nothing
    Set objVCmd = Nothing
    Set objVText = Nothing
    Set rsPhone = Nothing
    Set dbPhone = Nothing
    Set wsPhone = Nothing
    '
End Sub


Private Sub List1_DblClick()
    '
    ' select name from the list
    '
    Dim cReturn As String
    '
    If List1.ListIndex > 0 Then
        cReturn = Left(List1.List(List1.ListIndex), 20)
        txtDial = LookUp(cReturn)
    End If
    '
End Sub

Private Sub mnuFileItem_Click(Index As Integer)
    '
    ' handle user clicks
    '
    Select Case Index
        Case 0 ' new
            cmdPhone_Click 0
        Case 1 ' edit
            cmdPhone_Click 1
        Case 2 ' delete
            cmdPhone_Click 2
        Case 4 ' place call
            cmdDial_Click
        Case 6 ' exit
            Unload Me
    End Select
    '
End Sub

Private Sub mnuHelpItem_Click(Index As Integer)
    '
    Select Case Index
        Case 0 ' help screen
            frmHelp.Show vbModal
        Case 1 ' about
            frmAbout.Show vbModal
    End Select
    '
End Sub
