Attribute VB_Name = "modFaxBack"
Option Explicit
'
' fax variables
Public cFAXPrefix As String ' file prefix
Public cFAXSuffix As String ' file tail
Public cTestFAXAddr As String ' local FAX machine
Public cFAXFolder As String ' document folder
'
' SMAPI variables
Public lReturn As Long ' return flag
Public lSession As Long ' session handle
Public udtMessage As MapiMessage ' message object
Public udtRecip As MapiRecip ' recipient object
Public udtRecips() As MapiRecip ' recipient collection
Public udtFile As MapiFile ' attachment object
Public udtFiles() As MapiFile ' attachment collection

Public Function FileExists(cFile As String) As Integer
    '
    ' return TRUE if found, FALSE if not
    '
    Dim x  As Integer
    x = FreeFile
    '
    On Error Resume Next
    Open cFile For Input As x
    If Err = 0 Then
        FileExists = True
    Else
        FileExists = False
    End If
    Close x
    '
End Function

Public Sub CenterForm(frm As Form)
    '
    ' place form in center of display
    '
    frm.Left = (Screen.Width - frm.Width) / 2
    frm.Top = (Screen.Height - frm.Height) / 2
    '
End Sub

Public Sub SMAPIStart(lhWnd As Long, cLogID As String)
    '
    ' start an SMAPI session
    '
    lReturn = MAPILogon(lhWnd, cLogID, "", MAPI_LOGON_UI And MAPI_NEW_SESSION, 0, lSession)
    If lReturn <> SUCCESS_SUCCESS Then
        MsgBox MAPIErr(lReturn)
        End
    End If
    '
End Sub

Public Sub SMAPIEnd(lhWnd As Long)
    '
    ' end an SMAPI session
    '
    lReturn = MAPILogoff(lSession, lhWnd, 0, 0)
    '
End Sub

Public Sub SendSMAPIFax(lhWnd As Long, cFile As String, cRecipient As String)
    '
    ' queue up an smapi fax message
    '
    
    '
    ' get simple file name
    Dim cName As String
    cName = Mid(cFile, Len(cFAXFolder) + 2, 255)
    '
    ' make message
    udtMessage.Subject = "Requested FAX From FaxBack(tm)"
    udtMessage.NoteText = "Here's the FAX document you requested from FaxBack(tm)." & Chr(13) & Chr(13) & " #"
    '
    ' make attachment
    ReDim udtFiles(1)
    udtFiles(0).Position = Len(udtMessage.NoteText) - 1
    udtFiles(0).PathName = cFile
    udtFiles(0).FileName = cName
    udtFiles(0).FileType = 0
    '
    ' make recipient
    udtRecip.Reserved = 0
    udtRecip.RecipClass = 1
    udtRecip.Name = "FAX:FaxBack_Request@" & cRecipient
    udtRecip.Address = "FAX:FAXBack_Request@" & cRecipient
    udtRecip.EIDSize = 100
    udtRecip.EntryID = ""
    '
    ' update message
    udtMessage.RecipCount = 1
    udtMessage.FileCount = 1
    '
    ' now call sendmail w/o dialog
    lReturn = MAPISendMail(lSession, lhWnd, udtMessage, udtRecip, udtFiles(0), &H0, 0)
    '
End Sub

