VERSION 4.00
Begin VB.Form frmVCmd 
   Caption         =   "Voice Command Demo"
   ClientHeight    =   4350
   ClientLeft      =   1200
   ClientTop       =   1815
   ClientWidth     =   6825
   Height          =   4755
   Left            =   1140
   LinkTopic       =   "Form1"
   ScaleHeight     =   4350
   ScaleWidth      =   6825
   Top             =   1470
   Width           =   6945
   Begin VB.CommandButton cmdCBack 
      Caption         =   "Call &Back"
      Height          =   495
      Left            =   1560
      TabIndex        =   15
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton cmdList 
      Caption         =   "&Make List"
      Height          =   495
      Left            =   1560
      TabIndex        =   14
      Top             =   2580
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "R&emove"
      Height          =   495
      Left            =   1560
      TabIndex        =   13
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Timer Timer1 
      Left            =   1200
      Top             =   2640
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "&Add Items"
      Height          =   495
      Left            =   1560
      TabIndex        =   11
      Top             =   720
      Width           =   1215
   End
   Begin VB.Frame fraMenuCmd 
      Caption         =   "Create Command Flags"
      Height          =   1095
      Left            =   3000
      TabIndex        =   5
      Top             =   120
      Width           =   3615
      Begin VB.OptionButton optMenuCmd 
         Caption         =   "Open New"
         Height          =   255
         Index           =   4
         Left            =   1920
         TabIndex        =   10
         Top             =   240
         Width           =   1095
      End
      Begin VB.OptionButton optMenuCmd 
         Caption         =   "Open Always"
         Height          =   255
         Index           =   3
         Left            =   1920
         TabIndex        =   9
         Top             =   480
         Width           =   1335
      End
      Begin VB.OptionButton optMenuCmd 
         Caption         =   "Create Temp"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   8
         Top             =   720
         Value           =   -1  'True
         Width           =   1215
      End
      Begin VB.OptionButton optMenuCmd 
         Caption         =   "Create Always"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   7
         Top             =   480
         Width           =   1335
      End
      Begin VB.OptionButton optMenuCmd 
         Caption         =   "Create New"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   6
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.CommandButton cmdCrMenu 
      Caption         =   "&Create Menu"
      Height          =   495
      Left            =   1560
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdSleep 
      Caption         =   "&Sleep"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton cmdAwake 
      Caption         =   "&Awake"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdReg 
      Caption         =   "&Register"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lblCBResults 
      Alignment       =   1  'Right Justify
      Caption         =   "Callback Results:"
      Height          =   555
      Left            =   2880
      TabIndex        =   19
      Top             =   1920
      Width           =   855
   End
   Begin VB.Label lblPolling 
      Alignment       =   1  'Right Justify
      Caption         =   "Polling Results:"
      Height          =   435
      Left            =   2880
      TabIndex        =   18
      Top             =   1320
      Width           =   855
   End
   Begin VB.Label lblCallBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   495
      Left            =   3900
      TabIndex        =   17
      Top             =   1920
      Width           =   2715
   End
   Begin VB.Label lblResults 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "lblResults"
      Height          =   495
      Left            =   3900
      TabIndex        =   16
      Top             =   1320
      Width           =   2715
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "lblStatus"
      Height          =   495
      Left            =   120
      TabIndex        =   12
      Top             =   2580
      Width           =   1215
   End
   Begin VB.Label lblAwake 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1920
      Width           =   1215
   End
End
Attribute VB_Name = "frmVCmd"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim objVCmd As Object ' top-level boject
Dim objVMenu As Object ' child object
Dim lMenuIndex As Long ' menu index

Private Sub cmdAdd_Click()
    '
    ' add a new item to the menu
    '
    Dim x As Integer
    '
    For x = 1 To 4
        lMenuIndex = x
        objVMenu.Add lMenuIndex, "Line " & CStr(x), "Item List", "Make an Item List"
        '
        'objVMenu.hWndMenu = Me.hWnd ' for this window
        objVMenu.Active = True ' turn it on
        '
    Next x
    '
    MsgBox "Menu Complete"
    '
End Sub

Private Sub cmdAwake_Click()
    '
    ' wake up the SR engine
    '
    objVCmd.Awake = True
    lblAwake.Caption = "SR Engine is Awake"
    '
End Sub

Private Sub cmdCBack_Click()
    '
    ' register callback
    '
    objVCmd.Callback = App.EXEName & ".clsCallBack"
    '
End Sub

Private Sub cmdCrMenu_Click()
    '
    ' create a new menu
    '
    Dim iType As Integer
    Dim cMenuCmd As String
    Dim cMenuState As String
    Dim lMenuLangID As Long
    Dim cDialect As String
    Dim cAppName As String
    '
    ' set default stuff
    cAppName = App.EXEName ' this app
    cMenuState = frmVCmd.Caption ' this window
    cDialect = "" ' use default
    lMenuLangID = 1033 ' US lang nbr
    '
    ' get menu creation type
    iType = IIf(optMenuCmd(0), vcmdmc_CREATE_NEW, iType)
    iType = IIf(optMenuCmd(1), vcmdmc_CREATE_ALWAYS, iType)
    iType = IIf(optMenuCmd(2), vcmdmc_CREATE_TEMP, iType)
    iType = IIf(optMenuCmd(3), vcmdmc_OPEN_ALWAYS, iType)
    iType = IIf(optMenuCmd(4), vcmdmc_OPEN_EXISTING, iType)
    '
    ' now create an empty menu
    Set objVMenu = objVCmd.MenuCreate(cAppName, cMenuState, lMenuLangID, cDialect, iType)
    '
End Sub

Private Sub cmdList_Click()
    '
    ' add a list command
    ' build a list
    ' activate the menu
    '
    lMenuIndex = lMenuIndex + 1
    objVMenu.Active = False
    objVMenu.Add lMenuIndex, "Show <CustomerName>", "Name List", "Display Names"
    objVMenu.ListSet "CustomerName", 3, "Smith" & Chr(0) & "Lee" & Chr(0) & "Shannon" & Chr(0)
    objVMenu.Active = True
    '
End Sub

Private Sub cmdReg_Click()
    '
    ' register w/ SR engine
    '
    objVCmd.Register "" ' use default location
    '
End Sub

Private Sub cmdSleep_Click()
    '
    ' tell SR engine to stop listening
    '
    objVCmd.Awake = False
    lblAwake.Caption = "SR Engine is Sleeping"
    '
End Sub

Private Sub Command1_Click()
    '
    ' remove menus from the list
    '
    Dim lLoop As Long
    '
    For lLoop = lMenuIndex To 1 Step -1
        objVMenu.Remove (lLoop)
    Next lLoop
    '
    lMenuIndex = 0
    '
    MsgBox "Menus Removed"
    '
End Sub

Private Sub Form_Load()
    '
    ' create new voice command object
    '
    Set objVCmd = CreateObject("Speech.VoiceCommand")
    '
    Timer1.Interval = 500
    Timer1.Enabled = True
    '
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '
    ' destroy the voice command objects
    '
    Set objVCmd = Nothing
    Set objVMenu = Nothing
    '
End Sub

Private Sub Timer1_Timer()
    '
    ' look for menu hit
    '
    Dim lHeard As Long
    '
    lHeard = objVCmd.CommandSpoken
    lblstatus = "Menu ID: [" & CStr(lHeard) & "]"
    '
    Select Case lHeard
        Case 0 ' no command
            ' na
        Case 1 ' beep command
            lblResults = "Line 1"
        Case 2
            lblResults = "Line 2"
        Case 3
            lblResults = "Line 3"
        Case 4
            lblResults = "Line 4"
        Case 5
            lblResults = "Show"
    End Select
    '
    lHeard = 0
    objVCmd.CommandSpoken = 0
    '
End Sub
